#include <Application.h>
#include <InterfaceKit.h>

/*
	Tests BArchivable implementation for different BViews.
*/
class TestApp: public BApplication
{
	public:
	TestApp(): BApplication("application/x-vnd.mk-testapp")
	{
		BWindow *window = new BWindow(BRect(20,20,330,220),"BArchivable Test",  B_DOCUMENT_WINDOW_LOOK, B_NORMAL_WINDOW_FEEL, B_QUIT_ON_WINDOW_CLOSE);
		window->Show();
		
		BView *view = new BView(window->Bounds(),"Container",0,B_FOLLOW_ALL);
		window->AddChild(view);
		

		BMessage archive2;
		BButton *button = new BButton(BRect(20,10,120,30),"Button", "Label", NULL, 0,100);
		button->Archive(&archive2, true);
		view->AddChild(dynamic_cast<BView*>(instantiate_object(&archive2)));	

		BMessage archive;
		BSlider *slider = new BSlider(BRect(20,40,120,70),"Slider", "Label", NULL, 0,100);
		slider->Archive(&archive, true);
		// compare this...
		view->AddChild(dynamic_cast<BView*>(instantiate_object(&archive)));	
		// to this ...
		//view->AddChild(slider);	
	}	
};

int main() 
{
	new TestApp();
	be_app->Run();
	return 0;
}
